(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["QT"] = factory();
	else
		root["QT"] = factory();
})(typeof self !== 'undefined' ? self : this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["isInApp"] = isInApp;
/* harmony export (immutable) */ __webpack_exports__["config"] = config;
/* harmony export (immutable) */ __webpack_exports__["search"] = search;
/* harmony export (immutable) */ __webpack_exports__["getOfflineDict"] = getOfflineDict;
/* harmony export (immutable) */ __webpack_exports__["shareUrl"] = shareUrl;
/* harmony export (immutable) */ __webpack_exports__["shareText"] = shareText;
/* harmony export (immutable) */ __webpack_exports__["sharePoster"] = sharePoster;
/* harmony export (immutable) */ __webpack_exports__["speak"] = speak;
/* harmony export (immutable) */ __webpack_exports__["setFavor"] = setFavor;
/* harmony export (immutable) */ __webpack_exports__["getFavor"] = getFavor;
/* harmony export (immutable) */ __webpack_exports__["setValue"] = setValue;
/* harmony export (immutable) */ __webpack_exports__["getValue"] = getValue;
/* harmony export (immutable) */ __webpack_exports__["setSetting"] = setSetting;
/* harmony export (immutable) */ __webpack_exports__["getSetting"] = getSetting;
/* harmony export (immutable) */ __webpack_exports__["openUrl"] = openUrl;
/* harmony export (immutable) */ __webpack_exports__["openPage"] = openPage;
/* harmony export (immutable) */ __webpack_exports__["setVoiceLevelIndicator"] = setVoiceLevelIndicator;
/* harmony export (immutable) */ __webpack_exports__["startRecord"] = startRecord;
/* harmony export (immutable) */ __webpack_exports__["stopRecord"] = stopRecord;
/* harmony export (immutable) */ __webpack_exports__["startSpeechRecognition"] = startSpeechRecognition;
/* harmony export (immutable) */ __webpack_exports__["stopSpeechRecognition"] = stopSpeechRecognition;
/* harmony export (immutable) */ __webpack_exports__["startSpeechEvaluate"] = startSpeechEvaluate;
/* harmony export (immutable) */ __webpack_exports__["stopSpeechEvaluate"] = stopSpeechEvaluate;
/* harmony export (immutable) */ __webpack_exports__["userLogin"] = userLogin;
/* harmony export (immutable) */ __webpack_exports__["userInfo"] = userInfo;
/* harmony export (immutable) */ __webpack_exports__["toast"] = toast;
/* harmony export (immutable) */ __webpack_exports__["checkSystemVolume"] = checkSystemVolume;
/* harmony export (immutable) */ __webpack_exports__["configNavigationBar"] = configNavigationBar;
/* harmony export (immutable) */ __webpack_exports__["getOfflineData"] = getOfflineData;
/* harmony export (immutable) */ __webpack_exports__["onPageStatus"] = onPageStatus;
/* harmony export (immutable) */ __webpack_exports__["reload"] = reload;

var functionUniqueId = 1;
var callbackList = {};
var env = {};

function isAndroid() {
    return (navigator.userAgent.indexOf('Android') != -1);
}
    
function isIOS() {
    return (navigator.userAgent.indexOf('iPhone') != -1);
}

function isInApp() {
    return !!(navigator.userAgent.indexOf('QTranslator:qtbridge') != -1) || window.qtbridge || (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.qtbridge);
}

function iOSBridgeCallback(response) {
    if (typeof response == 'string')
        response = JSON.parse(response);
    var callbackKey = response.callbackId;
    if(callbackKey == "unsupport") {
        if(console) {
            console.log('ununsupport:' + response.op);
        }
    } 
    else if (typeof callbackList[callbackKey] == "function") {
        if (typeof response.params == 'string') {
            callbackList[callbackKey](JSON.parse(response.params));
        }
        else {
            callbackList[callbackKey](response.params);
        }
    }
}
window.iOSBridgeCallback = iOSBridgeCallback;

function AndroidBridgeCallback(response) {
    if (typeof response == 'string')
        response = JSON.parse(response);
    var callbackKey = response.callbackId;
    if(callbackKey == "unsupport") {
        if(console) {
            console.log('ununsupport:' + response.op);
        }
    }
    else if (typeof callbackList[callbackKey] == "function") {
        if (typeof response.params == 'string') {
            callbackList[callbackKey](JSON.parse(response.params));
        }
        else {
            callbackList[callbackKey](response.params);
        }
    }
}
window.AndroidBridgeCallback = AndroidBridgeCallback;

function generateFunctionID(foo) {
    if(!foo) {
        return "null";
    }
    var callbackId = 'cb_' + (functionUniqueId++) + '_' + new Date().getTime();
    callbackList[callbackId] = foo;  //这玩意没办法回收，所以有内存泄露
    return callbackId;
}

function callNativeBridge(op, params) {
    if (!op || !params) {
        return;
    }

    var bridgeParams = {};
    for(var key in params) {
        var param = params[key];
        if(typeof param == "function") {
            var functionId = generateFunctionID(param);
            bridgeParams[key + 'FunctionId'] = functionId;
        }
        else {
            bridgeParams[key] = param;
        }
    }

    if (isAndroid()) {
        //android
        if (window.WebViewJavascriptBridge)
            window.WebViewJavascriptBridge.callHandler('bridge', {
                'op': op,
                'params': bridgeParams,
                'env': env
            });
    } else if (isIOS()) {
        //ios
        if (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.qtbridge)
            window.webkit.messageHandlers.qtbridge.postMessage({
                'op': op, 
                'params': bridgeParams, 
                'env': env
            });
    }
}

//历史遗留原因， 新接口全部使用 callNativeBridge
function callNativeBridgeOld(op, params, callback) {
    if (!op || !params) {
        return;
    }

    var callbackFun;
    if(callback) {
        callbackFun = function (response) {
            if (typeof response == 'string') {
                response = JSON.parse(response);
            }
            callback(response);
        };
    }
    
    if (isAndroid()) {
        if (window.WebViewJavascriptBridge) {
            window.WebViewJavascriptBridge.callHandler('bridge', {
                'op': op,
                'params': params,
                'env': env
            }, callbackFun);
        }
    } else if (isIOS()) {
        if (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.qtbridge) {
            var callbackId = generateFunctionID(callbackFun);
            window.webkit.messageHandlers.qtbridge.postMessage({
                'op': op,
                'params': params,
                'env': env,
                'callbackId': callbackId
            });
        }
    }
}

function config(configObj) {
    env = configObj['environment'];    
}

function search(params) {
    if(!params || !params.word) {
        return;
    }

    var word = params["word"];
    var sessionUuid = params["sessionUuid"] || "";
    var callback = params['callback'];

    callNativeBridgeOld("search", {
        "word":word, 
        "sessionUuid": sessionUuid
    }, callback);
}


/**
 * getOfflineDict 获取某个单词的词典数据
 * @param {string} word - 要查询的单词.
 * @param {string} lang - 要查询的语种.
 * @param {function} function - 返回数据的回调函数.
 */
function getOfflineDict(params) {
    callNativeBridge("getOfflineDict", params);
}

function shareUrl(params) {
    callNativeBridge("shareUrl", params);
}

function shareText(params) {
    callNativeBridge("shareText", params);    
}

function sharePoster(params) {
    callNativeBridge("sharePoster", params);    
}

function speak(params) {
    callNativeBridge("speak", params);    
}

function setFavor(params) {
    callNativeBridge("setFavor", params);
}

function getFavor(params) {
    if(!params || !params.words || !params.callback) {
        return;
    }

    var words = params["words"];
    var callback = params['callback'];

    callNativeBridgeOld("getFavor", words, callback);
}

function setValue(params) {
    callNativeBridge("setValue", params);
}

function getValue(params) {
    if(!params || !params.key || !params.callback) {
        return;
    }

    var key = params["key"];
    var callback = params['callback'];

    callNativeBridgeOld("getValue", {
        "key":key, 
    }, callback);
}

function setSetting(params) {
    callNativeBridge("setSetting", params);
}

function getSetting(params) {
    if(!params || !params.key || !params.callback) {
        return;
    }

    var key = params["key"];
    var callback = params['callback'];

    callNativeBridgeOld("getSetting", {
        "key":key, 
    }, callback);
}

function openUrl(params) {
    callNativeBridge("openURL", params);
}

function openPage(params) {
    callNativeBridge("openPage", params);
}

function setVoiceLevelIndicator(params) {
    callNativeBridge("setVoiceLevelIndicator", params);
}

function startRecord(params) {
    callNativeBridge("startRecord", params);
}

function stopRecord(params) {
    callNativeBridge("stopRecord", params);
}

function startSpeechRecognition(params) {
    callNativeBridge("startSpeechRecognition", params);
}

function stopSpeechRecognition(params) {
    callNativeBridge("stopSpeechRecognition", params);
}

function startSpeechEvaluate(params) {
    callNativeBridge("startSpeechEvaluate", params);
}

function stopSpeechEvaluate(params) {
    callNativeBridge("stopSpeechEvaluate", params);
}

function userLogin(params) {
    callNativeBridge("userLogin", params);
}

function userInfo(params) {
    callNativeBridge("userInfo", params);
}

function toast(params) {
    callNativeBridge("toast", params);
}

function checkSystemVolume(params) {
    callNativeBridge("checkSystemVolume", params);
}

function configNavigationBar(params) {
    callNativeBridge("configNavigationBar", params);
}

/**
 * 获取离线页面的直出数据
 * parmas： callback
 */
function getOfflineData(params) {
    callNativeBridge("getOfflineData", params);
}

/**
 * 注册页面加载状态的回调函数
 * parmas： callback
 */
function onPageStatus(params) {
    callNativeBridge("onPageStatus", params);
}

/**
 * 刷新页面
 * parmas： callback
 */
function reload(params) {
    callNativeBridge("reload", params);
}



/***/ })
/******/ ]);
});