package com.qq.taf.net.udp;

import java.net.SocketAddress;
import java.util.HashMap;

public class ServerTimeOutGetter {
	private final static HashMap<SocketAddress, Integer> timeOuts = new HashMap<SocketAddress, Integer>();
	
	public static void addTimeOut(SocketAddress addr, int timeOut) {
		timeOuts.put(addr, timeOut);
	}
	
	public static int getTimeOut(SocketAddress addr, int defValue) {
		Integer value = timeOuts.get(addr);
		if(value == null) {
			return defValue;
		}
		else {
			return value;
		}
	}
}
