package com.qq.taf.proxy.exec;

import com.qq.taf.net.Session;
import com.qq.taf.proxy.SendMessage;
import com.qq.taf.proxy.conn.EndPointInfo;

public class TafNotSendException extends TafException{

	EndPointInfo config;
	SendMessage msg;
	Session session;
	
	public TafNotSendException(EndPointInfo config, SendMessage msg, Session session) {
		super(msg.getFuture().getSServantName()+" not send at "+config + " session_id:" + (session == null? "null": session.getID()));
		this.config = config ;
		this.msg = msg ;
		this.session = session;
	}

	public EndPointInfo getConfig() {
		return config;
	}

	public SendMessage getMsg() {
		return msg;
	}

}
