package com.qq.taf.net;

import java.util.concurrent.atomic.AtomicInteger;

/**
 * SessionId生成器
 * @author fanzhang
 */
public class SessionIdGenerator {
	
	private AtomicInteger generator;
	
	public SessionIdGenerator() {
		generator=new AtomicInteger(0);
	}

	public int newSessionId() {
		return generator.getAndIncrement();
	}
	
}
