package com.qq.taf.proxy.utils;

/**
 * 百毫秒级时间戳生成器（全局单例）
 * @author fanzhang
 */
public class Millis100TimeProvider {

	public static final Millis100TimeProvider INSTANCE=new Millis100TimeProvider();
	private TimeProvider timeProvider;
	
	private Millis100TimeProvider() {
		timeProvider=new TimeProvider("100ms",100);
	}
	
	public long currentTimeMillis() {
		return timeProvider.currentTimeMillis();
	}
	
}
